#!/bin/bash
## SERVIDOR DE DESTINO
DESTINATION="ns188.prodns.com.br"

## PORTA DO SERVIDOR DE DESTINO (PADRAO 22)
PORT=""

## USUARIO RESELLER A SER MIGRADO
RESELLER="vilec364"

## FOR PARA OBTER OS USUARIOS (DEVE SER COMENTADO SE FOR MIGRAR OS USUARIOS A PARTIR DE UM ARQUIVO)
for USER in `/root/bin/oi -c $RESELLER` ; do

## PARA MIGRAR MANUALMENTE OS USUARIOS QUE FALTAREM EM CASO DE FALHA
## for USER in `<users.txt` ; do 

## CRIA SKIP PARA GERAR CPMOVE ACIMA DE 10GB 
if [ ! -d "/etc/skipresbackup" ] ; then mkdir -p /etc/skipresbackup ; fi
if [ ! -e "/etc/skipresbackup/$USER" ] ; then touch /etc/skipresbackup/$USER ; fi

## ESTRUTURA DE DIRETORIOS E ARQUIVOS A SEREM CRIADOS
TMPDIR="/home/HG_MIGRACAO_TERRA/$RESELLER"
USERDIR="$TMPDIR/$USER"
PKGACCT="$USERDIR/pkgacct-$USER.txt"
RESTOREPKG="$USERDIR/restorepkg-$USER.txt"
RSYNC1="$USERDIR/rsync1-$USER.txt"
RSYNC2="$USERDIR/rsync2-$USER.txt"
USERIP="$USERDIR/userip-$USER.txt"
DUMPERROR="$USERDIR/dumperror-$USER.txt"

if [ -z "$PORT" ] ; then PORT=22 ; fi

if [ -e "$USERDIR" ] ; then  rm -rfv $USERDIR ; fi

## VERIFICA A VERSAO DO CPANEL PARA EFETUAR O REDIRECIONAMENTO INTERNO
CPANEL=$(/usr/bin/sudo ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no $DESTINATION -p $PORT "cat /usr/local/cpanel/version  | egrep -o '[0-9]{2}.[0-9]{2}'| sed 's/\.//g'")

## EFETUA O REDIRECIONAMENTO INTERNO E SALVA EM LOG
ZONE_SYNC_CPANEL_1146() {

OLDIP=`grep "Changed all instances of" $RESTOREPKG | head -n 1 | cut -d[ -f2 | cut -d] -f1`
NEWIP=`grep "Changed all instances of" $RESTOREPKG | head -n 1 | cut -d[ -f3 | cut -d] -f1` 

printf "IP_ANTIGO\t\tIP_NOVO\t\t\tDOMINIO" >> $USERIP
printf "\n" >> $USERIP

for DOMAIN in `grep "Changed all instances of" $RESTOREPKG |cut -d] -f3 |cut -c 5-` ; do
        cp -pv /var/named/$DOMAIN.db $USERDIR/$DOMAIN.db.bak
        replace $OLDIP $NEWIP -- /var/named/$DOMAIN.db 
        rndc reload 
        printf "%-10s\t\t" $OLDIP $NEWIP $DOMAIN >> $USERIP
        printf "\n" >> $USERIP
done 

}


## EFETUA REDIRECIONAMENTO INTERNO E SALVA EM LOG
ZONE_SYNC_CPANEL_1148() {

OLDIP=`grep "Changed all instances of" $RESTOREPKG |head -n 1 | cut -d[ -f5| cut -d] -f1`
NEWIP=`grep "Changed all instances of" $RESTOREPKG |head -n 1 | cut -d[ -f6| cut -d] -f1`

printf "IP_ANTIGO\t\tIP_NOVO\t\t\tDOMINIO" >> $USERIP
printf "\n" >> $USERIP

for DOMAIN in `grep "Changed all instances of" $RESTOREPKG |cut -d  ] -f6 | cut -c 5-` ; do
        cp -pv /var/named/$DOMAIN.db $USERDIR/$DOMAIN.db.bak
        replace $OLDIP $NEWIP -- /var/named/$DOMAIN.db
        rndc reload
        printf "%-10s\t\t" $OLDIP $NEWIP $DOMAIN >> $USERIP
        printf "\n" >> $USERIP
done

}

## CRIAR O DIRETORIO DE MIGRACAO SE NAO EXISTIR (SE JA EXISTIR O DIRETORIO DO USUARIO NO DESINO REMOVA PRIMEIRO)
if [ ! -d $USERDIR ] ; then mkdir -p $USERDIR ; fi
ssh $DESTINATION -p $PORT "if [ ! -d $USERDIR ] ; then mkdir -p $USERDIR ; fi"

## GERA O ARQUIVO CPMOVE E RESTAURA NO SERVIDOR DE DESTINO
/scripts/pkgacct --skiphomedir $USER $USERDIR | tee -a $PKGACCT
rsync -vazhP -e "ssh -p $PORT"  $USERDIR/cpmove-$USER.tar.gz $DESTINATION:$USERDIR
ssh $DESTINATION -p $PORT  "/scripts/restorepkg --skipres $USERDIR/cpmove-$USER.tar.gz" | tee -a $RESTOREPKG

## EFETUA RSYNC DO DIRETORIO HOME DO USUARIO PARA O DESTINO
rsync -vazhP -e "ssh -p $PORT" /home/$USER/ $DESTINATION:/home/$USER/ | tee -a $RSYNC1
rsync -vazhP -e "ssh -p $PORT" /home/$USER/ $DESTINATION:/home/$USER/ | tee -a $RSYNC2

## ATRIBUI O REDIRECIONAMENTO INTERNO DE ACORDO COM A VERSAO DO CPANEL
if [ "$CPANEL" -le "1146" ] ; then ZONE_SYNC_CPANEL_1146 ; fi
if [ "$CPANEL" -ge "1148" ] ; then ZONE_SYNC_CPANEL_1148 ; fi

## OBTEM O PREFIXO DO USUARIO NO MYSQL PARA REALIZAR O DUMP DOS BANCOS DE DADOS MYSQL
PREFIX=$(echo "$USER" |cut -c -8)

## EFETUA DUMP DE TODOS OS BANCOS DO USUARIO MANUALMENTE E REDIRECIONA FALHA PARA O ARQUIVO DE LOG
mysql -e "show databases" | grep -E "${PREFIX}_.*" &> /dev/null ; if [ `echo $?` = "0" ] ; then
for DB in `mysql -e "show databases" | grep -E "${PREFIX}_.*"` ; do
mysqldump -u root $DB &> /dev/null ; if [ `echo $?` = "0" ] ; then
mysqldump -u root $DB > $USERDIR/$DB.sql ; else
echo "---- $DB ----" >> $DUMPERROR ;
mysqldump -u root $DB > /dev/null 2>> $DUMPERROR ; fi ; done ; fi


## EFETUE DUMP DO BANCO MYSQL HORDE E ROUNDCUBE SE EXISTIR
for WEBMAIL in horde roundcube ; do
mysqldump -u root $WEBMAIL &> /dev/null ; if [ `echo $?` = "0" ] ; then
mysqldump -u root $WEBMAIL > $USERDIR/$WEBMAIL.sql ; else
echo "---- $WEBMAIL ----" >> $DUMPERROR ;
mysqldump -u root $WEBMAIL > /dev/null 2>> $DUMPERROR ; fi ; done

## EFETUA RSYNC DOS DADOS PARA O DESTINO
rsync -vazhP -e "ssh -p $PORT" $USERDIR/ $DESTINATION:$USERDIR/

## REMOVE SKIP CPMOVE ACIMA DE 10GB
if [ -e "/etc/skipresbackup/$USER" ] ; then rm -f /etc/skipresbackup/$USER ; fi

done

## COPIA WEBTEMPLATES
if [ -d "/var/cpanel/webtemplates/${RESELLER}" ] ; then
rsync --progress -vzahP /var/cpanel/webtemplates/${RESELLER}/ ${DESTINATION}:/var/cpanel/webtemplates/${RESELLER}/ ; fi ;

## COPIA PACKAGES
rsync -vazhP /var/cpanel/packages/${RESELLER}_* ${DESTINATION}:/var/cpanel/packages/ ;
