#!/bin/bash
#
# JOSE TERRA <jose.terra@hostgator.com.br>
# LINUX SYSTEMS ADMINISTRATOR II
# HOSTGATOR BRAZIL (C) 2015
#

SHOW_HELP() {

printf "
[?] VERIFICAR OS BACKUPS DOS BANCOS DISPONIVEIS NO SERVIDOR NAS
bash <(GET http://git.hostgator.com.br/jose.terra/dev/raw/master/nasdb) --check --user [USUARIO]

[?] COPIAR OS BACKUPS DOS BANCOS DO SERVIDOR NAS PARA O SERVIDOR CORRENTE
bash <(GET http://git.hostgator.com.br/jose.terra/dev/raw/master/nasdb) --copy --user [USUARIO] --ticket [TICKET]

[!] O SCRIPT DEVE SER EXECUTADO A PARTIR DO SERVIDOR ONDE SE ENCONTRA O DOMINIO/USUARIO
"
printf "\n"

}

CHECK_USER_PREFIX() {

if [ `echo -n "$USER" | wc -c` -gt "8" ] ; then
	PREFIX=$(echo "$USER" |cut -c -8)
	USER=$PREFIX
fi

}

CHECK_NAS_CONECTION() {

printf "\n"
printf "[!] VERIFICANDO CONEXAO COM O SERVIDOR NAS '${NASSERVER}' ..."
printf "\n"

ssh -q -o ConnectTimeout=2 -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP exit &>/dev/null
if [ `echo $?` != "0" ] ; then
        ssh -q -o ConnectTimeout=8 -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP exit &>/dev/null
        if [ `echo $?` != "0" ] ; then
                printf "[!] ACESSO AO SERVIDOR NAS '${NASSERVER}' INDISPONIVEL NO MOMENTO !!"
                printf "\n"
                printf "[!] REALIZE UM NOVO TESTE DENTRO DE INSTANTES E SE PERSISTIR ABRA UM TICKET AMERICANO (EUA) !!"
                printf "\n\n"
                printf "SERVER: $SERVER"
                printf "\n"
                printf "NAS SERVER: ${NASSERVER}"
                printf "\n"
                printf "IP: $NASIP"
                printf "\n\n"
                printf "==============="
                printf "\n"
                printf "ERROR LOG"
                printf "\n"
                printf "==============="
                printf "\n"
                ssh -v -o ConnectTimeout=2 -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP exit
                printf "\n"
                exit 0
        fi
fi
		
}


if [ "$#" -lt "3" ] ; then SHOW_HELP ; exit 0 ; fi

case $1 in

--check)
OPTION="CHECK"
;;

--copy)
OPTION="COPY"
;;

*)
SHOW_HELP
;;

esac


if [ "$OPTION" = "CHECK" ] ; then

while [ "$2"  != "" ] ; do

case $2 in

--user)
USER="$3"
shift 2
;;

*)
SHOW_HELP
;;

esac
done

SERVER=$(hostname)
NASIP=$(curl -s http://nas.hostgator.com/assign.php?fullquery=$SERVER | head -n1)
NASHOME=$(curl -s http://nas.hostgator.com/assign.php?fullquery=$SERVER | head -2| tail -1)
NASDIR="$NASHOME/$SERVER"
MYSQL1="$NASDIR/var/lib/mysql"
MYSQL2="$NASDIR/var/lib/mysql.innodbs"
MYSQL3="$NASDIR/var/lib/mysql.innodbs.2"
NASSERVER=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP "hostname")

CHECK_NAS_CONECTION

printf "[!] ACESSANDO O SERVIDOR NAS '${NASSERVER}'..."
printf "\n\n"
sleep 5

CHECK_USER_PREFIX

MYSQL1_COUNT=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP " ls -la $MYSQL1 | grep -E "${USER}_.*" | wc -l ")

MYSQL1_OUTPUT=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP " ls -la $MYSQL1 | grep -E "${USER}_.*" ")

echo "NAS DIRECTORY '$MYSQL1'..."
echo "DATABASE FOUND '$MYSQL1_COUNT'..."
echo "$MYSQL1_OUTPUT"  

MYSQL2_COUNT=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP " ls -la $MYSQL2 | grep -E "${USER}_.*" | wc -l ")

MYSQL2_OUTPUT=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP " ls -la $MYSQL2 | grep -E "${USER}_.*" ")

echo -e "\nNAS DIRECTORY '$MYSQL2'..."
echo "DATABASE FOUND '$MYSQL2_COUNT'..."
echo "$MYSQL2_OUTPUT" 

MYSQL3_COUNT=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP " ls -la $MYSQL3 | grep -E "${USER}_.*" | wc -l ")

MYSQL3_OUTPUT=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP " ls -la $MYSQL3 | grep -E "${USER}_.*" ")

echo -e "\nNAS DIRECTORY '$MYSQL3'..."
echo "DATABASE FOUND '$MYSQL3_COUNT'..."
echo "$MYSQL3_OUTPUT"

echo -e "\n"

fi


if [ "$OPTION" = "COPY" ] ; then

while [ "$2" != "" ] ; do

case $2 in

--user)
USER="$3"
shift 2
;;

--ticket)
TICKET="$3"
shift 2
;;

esac
done

SERVER=$(hostname)
NASIP=$(curl -s http://nas.hostgator.com/assign.php?fullquery=$SERVER | head -n1)
NASHOME=$(curl -s http://nas.hostgator.com/assign.php?fullquery=$SERVER | head -2| tail -1)
NASDIR="$NASHOME/$SERVER"
MYSQL1="$NASDIR/var/lib/mysql"
MYSQL2="$NASDIR/var/lib/mysql.innodbs"
MYSQL3="$NASDIR/var/lib/mysql.innodbs.2"
TICKETDIR="/home/hgtransf/nasdb/$TICKET"
MYSQL1DIR="$TICKETDIR/mysql"
MYSQL2DIR="$TICKETDIR/mysql.innodbs"
MYSQL3DIR="$TICKETDIR/mysql.innodbs.2"
NASSERVER=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP "hostname")

CHECK_BACKUP_DIRECTORY() {

if [ -e "$MYSQL1DIR" ] ; then
	MYSQL1DIR_COUNT=$(ls -la $MYSQL1DIR | grep -E "${USER}_.*" | wc -l)	
	printf "\n"
        printf "SUBDIRECTORY '$MYSQL1DIR'..."
        printf "\n"
	printf "DATABASE FOUND '$MYSQL1DIR_COUNT'..."
	printf "\n"
        ls -la $MYSQL1DIR |  grep -E "${USER}_.*"       
fi      

if [ -e "$MYSQL2DIR" ] ; then
        MYSQL2DIR_COUNT=$(ls -la $MYSQL2DIR |  grep -E "${USER}_.*" | wc -l)
	printf "\n"
	printf "SUBDIRECTORY '$MYSQL2DIR'..."
        printf "\n"
        printf "DATABASE FOUND '$MYSQL2DIR_COUNT'..."
        printf "\n"
	ls -la $MYSQL2DIR |  grep -E "${USER}_.*"       
fi      

if [ -e "$MYSQL3DIR" ] ; then
	MYSQL3DIR_COUNT=$(ls -la $MYSQL3DIR |  grep -E "${USER}_.*" | wc -l)
        printf "\n"
        printf "SUBDIRECTORY '$MYSQL3DIR'..."
        printf "\n"
	printf "DATABASE FOUND '$MYSQL3DIR_COUNT'..."
        printf "\n"
      	ls -la $MYSQL3DIR |  grep -E "${USER}_.*"
fi

}

CHECK_USER_PREFIX

if [[ $TICKET =~ ^[A-Z]{3}-[0-9]{6} ]] ; then
	if [ -d "${TICKETDIR}" ] ; then
		printf "\n"
		printf "[!] JA EXISTE O DIRETORIO DE BACKUP '$TICKETDIR' COM O NUMERO DO TICKET NESTE SERVIDOR !!"	 
		printf "\n"
		printf "[!] VERIFIQUE OU RENOMEIE PARA CONTINUAR !!"
		printf "\n\n"
		printf "[!] ACESSANDO O DIRETORIO DE BACKUP EXISTENTE '$TICKETDIR'..."
		printf "\n"
		sleep 10		
		CHECK_BACKUP_DIRECTORY
		printf "\n"
		exit 0 
	fi 
else
		printf "\n"
		printf "[!] O NUMERO DO TICKET E INVALIDO !!"
		printf "\n"		
		printf "[!] DIGITE O NUMERO DO TICKET NO FORMATO VALIDO 3LETRAS-6NUMEROS (ABC-123456) !!"
		printf "\n\n"
		exit 0 
fi

CHECK_NAS_CONECTION

printf "[!] INICIANDO COPIA DOS DADOS PARA O DIRETORIO DE BACKUP '$TICKETDIR'..."
printf "\n\n"
sleep 10

MYSQL1_COUNT=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP " ls -la $MYSQL1 | grep -E "${USER}_.*" | wc -l ")

if [ "$MYSQL1_COUNT" != "0" ] ; then

mkdir -p $MYSQL1DIR

rsync -avzP -e 'ssh -i /home/hgbackupdir/backupkey' root@$NASIP:$MYSQL1/${USER}_* $MYSQL1DIR 

fi

MYSQL2_COUNT=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP " ls -la $MYSQL2 | grep -E "${USER}_.*" | wc -l ")

if [ "$MYSQL2_COUNT" != "0" ] ; then

mkdir -p $MYSQL2DIR

rsync -avzP -e 'ssh -i /home/hgbackupdir/backupkey' root@$NASIP:$MYSQL2/${USER}_* $MYSQL2DIR

fi

MYSQL3_COUNT=$(ssh -q -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no -i /home/hgbackupdir/backupkey $NASIP " ls -la $MYSQL3 | grep -E "${USER}_.*" | wc -l ")

if [ "$MYSQL3_COUNT" != "0" ] ; then

mkdir -p $MYSQL3DIR

rsync -avzP -e 'ssh -i /home/hgbackupdir/backupkey' root@$NASIP:$MYSQL3/${USER}_* $MYSQL3DIR

fi

printf "\n"
printf "[!] COPIA DOS DADOS FINALIZADA COM SUCESSO !!"
printf "\n"
printf "[!] ACESSANDO O DIRETORIO DE BACKUP '$TICKETDIR'..."
printf "\n"
sleep 10
CHECK_BACKUP_DIRECTORY
printf "\n"

fi
