#!/bin/bash
# Jose Terra <jose.terra@endurance.com>
# Linux Systems Administrator II

RED=$(tput setaf 1)
RESET=$(tput sgr0)
GREEN=$(tput setaf 2)

if [ "$#" -lt "2" ] ; then echo -e '\n[!] Use bash <(GET git.gatorterra.com/nasfile.sh) --user [USER]\n' ; exit 0 ; fi

case $1 in

  --user|-u)
  user=$2
  shift 2
  ;;

esac

countcomp=0
countuncom=0

for logcomp in $(ls -al /home/hgbackupdir/logs/backup_verbose.log.*.gz| tail -3 | awk '{ print $9}') ; do

  skip=$(zcat $logcomp |grep -E "Skipping \b${user}\b due to skip file in" | awk '{ print $1}')
  if [ "$skip" = "Skipping" ] ; then skip="${RED}SKIPPED${RESET}" ; else skip="${GREEN}NO SKIPPED${RESET}" ; fi
  if [ `zcat $logcomp | egrep 'Backing up user' | grep -E "\b${user}\b" | wc -l` != "0" ] ; then
  zcat $logcomp |egrep 'Backing up user' | printf "$(grep -E "\b${user}\b") - $logcomp [$skip]\n"
  countcomp=$(($countcomp +1))
  fi

done

for loguncom in $(ls -al /home/hgbackupdir/logs/backup_verbose.log.*[0-9]| tail -3 | awk '{ print $9}') ; do

  skip=$(grep -E "Skipping \b${user}\b due to skip file in" $loguncom | awk '{ print $1}')
  if [ "$skip" = "Skipping" ] ; then skip="${RED}SKIPPED${RESET}" ; else skip="${GREEN}NO SKIPPED${RESET}" ; fi
  if [ `cat $loguncom | egrep 'Backing up user' | grep -E "\b${user}\b" | wc -l` != "0" ] ; then
  cat $loguncom |egrep 'Backing up user' | printf "$(grep -E "\b${user}\b") - $loguncom [$skip]\n"
  countuncom=$(($countuncom +1))
  fi

done


if [ $countcomp = "0" ] && [ $countuncom = "0" ] ; then echo -e '\n[!] User does not exists\n' ; fi
